﻿// Generated by LateBindingApi.CodeGenerator
using System;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Runtime.InteropServices.ComTypes;

namespace LateBindingApi.Core
{
    /// <summary>
    /// Sink Helper Base Class for an Event Interface Sink helper class
    /// </summary>
    public abstract class SinkHelper : IDisposable
    {
        #region Fields

        private COMObject        _eventClass;
        private IConnectionPoint _connectionPoint;
        private int              _connectionCookie;
        private Guid             _interfaceId;

        #endregion

        #region Construction

        public SinkHelper(COMObject eventClass)
        {
            _eventClass = eventClass;
        }

        #endregion

        #region Internal Methods

        public void SetupEventBinding(string guid)
        {
            _interfaceId = new Guid(guid);
            if (true == Settings.EnableEvents)
            {
                IConnectionPointContainer connectionPointContainer = (IConnectionPointContainer)_eventClass.UnderlyingObject;
                connectionPointContainer.FindConnectionPoint(ref _interfaceId, out _connectionPoint);
                _connectionPoint.Advise(this, out _connectionCookie);
            }
        }

        public void RemoveEventBinding()
        {
            if (_connectionCookie != 0)
            {
                _connectionPoint.Unadvise(_connectionCookie);
                Marshal.ReleaseComObject(_connectionPoint);
                _connectionPoint = null;
                _connectionCookie = 0;
            }
        }

        #endregion

        #region IDisposable Members

        public void Dispose()
        {
            RemoveEventBinding();
        }
        
        #endregion
    }
}
